{ %pragma listlvl:2; }
{
 ******************************************************************************
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *                        MMM    MMM   XXX      XXX  DDDDDDDD                 *
 *                        MMMM  MMMM    XXX    XXX   DDDDDDDDDD               *
 *                        MM MMMM MM     XXX  XXX    DD      DDD              *
 *                        MM  MM  MM      XXXXXX     DD       DD              *
 *                        MM      MM       XXXX      DD       DD              *
 *          T  H  E       MM      MM       XXXX      DD       DD              *
 *                        MM      MM      XXXXXX     DD       DD              *
 *                        MM      MM     XXX  XXX    DD      DDD              *
 *                        MM      MM    XXX    XXX   DDDDDDDDDD               *
 *                       MMMM    MMMM  XXX      XXX  DDDDDDDD                 *
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *                 SSSSS Y     Y  SSSSS TTTTTTT EEEEEE M     M                *
 *                S       Y   Y  S         T    E      MM   MM                *
 *                S        Y Y   S         T    E      M M M M                *
 *                 SSSS     Y     SSSS     T    EEEEE  M  M  M                *
 *                     S    Y         S    T    E      M     M                *
 *                     S    Y         S    T    E      M     M  ..            *
 *                SSSSS     Y    SSSSS     T    EEEEEE M     M  ..            *
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *              ---  Version  3.999 000 alpha -- 31/10/2010 ---               *
 *                                                                            *
 *                by :                                                        *
 *                                                                            *
 *                     P. Wolfers                                             *
 *                         c.n.r.s.                                           *
 *                         Institut Neel (MCMF), Bat F,                       *
 *                         B.P.  166 X   38042  Grenoble Cedex                *
 *                                                FRANCE.                     *
 *                                                                            *
 *                                                                            *
 ******************************************************************************


///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                                                                           //
//                     Global Public Licence (GPL)                           //
//                                                                           //
//                                                                           //
//    This license described in this file overrides all other licenses       //
//    that might be specified in other files for this software.              //
//                                                                           //
//    This program is free software; you can redistribute it and/or          //
//    modify it under the terms of the GNU Lesser General Public             //
//    License as published by the Free Software Foundation; either           //
//    version 2.1 of the License, or (at your option) any later version.     //
//                                                                           //
//    This software is distributed in the hope that it will be useful,       //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      //
//    Library General Public License for more details.                       //
//                                                                           //
//    You should have received a copy of the GNU Lesser General Public       //
//    License along with this library (see COPYING.LIB); if not, write to    //
//    the Free Software Foundation :                                         //
//                         Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////



*******************************************************************************
*                                                                             *
*                                                                             *
*     MXD   Expression  and  Crystallographic  Object  Tree   Environment     *
*                                                                             *
*                                                                             *
*******************************************************************************


}


{****************     CPAS  version    *****************}
{
        *** Modification(s) from major version ***


                  ----

                 NOTHING

                  ----

}


  %include 'MXDSRC:mxd_tree_env';               { Get all tree definitions }



const
  task_name    =             'MXD-LSQ'; { Task name for the Least-Squares program }

  mxd_lsq_envf =    'mxd_lsq_env.pcdf'; { The LSQ formulae environment }


  flt_max      =               1.0e+30; { Define the largest floatting number constant }



[external]
var
  itopvect,                             { Top of f2 Matrix and Vectors }
  idervec,                              { Origine of calc. partial derivative table }
  icoltrm,                              { Origine of LSQ column vector }
  ishfvec,                              { Origine of the shift LSQ vector }
  ineumem,                              { Origine of +/- neutron flipping memory tb. }
  ivtfn,   ivtfm,                       { Origine of the fn and fm partial derivative tables }
  ivtnr,   ivtni,                       { Origines of fn derivate tables ... }
  ivrx, ivix, ivry,
  iviy, ivrz, iviz:            integer; { ... and also for fmx,y,z }

  mdtab:                       ftb_ptr; { Table of LSQ block Matrixs and partial derivative vectors }



  nbsing_nmax,                          { Maximum number of singularities to continue the fit }
  lsq_savcycle,                         { Save cycle period in LSQ_CYCLE (0 = no save) }
  lsq_mxcateg,                          { Maximum of category number for an elligible reflection }
  lsq_ncycle:                  integer; { Number of cycle to perform }

  sithsl_max,                           { Maximum for SIN(theta)/Lambda for an eligible reflection }
  sithsl_min,                           { Minimum for SIN(theta)/Lambda for an eligible reflection }
  correl_max,                           { Edge for correlation output }
  matdiag_max,                          { Low Limit of matrix pivot to signal a singularity }
  lhkl_reject,                          { Max. of <delta>/<sigma> for an eligible reflection }
  lhkl_list:                   mxd_flt; { Minimum level for <delta>/<sigma> for reflection listing }

  bsigcor_out,                          { Flag for sigma and correlation output after the last cycle (on specific file) }
  bfour_out,                            { Flag for Fourier output after the last cycle (on specific file) }
  batom_out,                            { Flag for Atom list output after the last cycle (on specific file) }
  bistr_list,                           { Flag for listing of initial structure description }
  bfstr_list,                           { Flag for listing of final structure description }
  bcorrmat_list,                        { Flag for Full correlation matrix listing after the last cycle }
  bsymtry_list,                         { Flag for symmetry operator listing }
  bfmag_list,                           { Flag for Magnetic structure factor output }
  bpfmag_list,                          { Flag for Projected Magnetic structure factor output }
  bpsta_list,                           { Flag for particular Residu listing on the last LSQ cycle }
  bpsta_cylst,                          { Flag for particular Residu listing for each LSQ cycle }
  bparm_list,                           { Flag for listing LSQ_PARM on last cycle }
  bresult_list,                         { Flag for result (LSQ_VAR) listing on each cycle }
  bacconv_lsq,                          { Flag for convergence acceleration process management }
  bhkl_list,                            { Flag for HKL reflection listing at the last LSQ cycle }
  bhkl_cylst:                  boolean; { Flag for HKL reflection listing for each LSQ cycle }



procedure INITIAL_TASKS; external;

procedure EXECUTE_LSQ_FIT; external;

procedure FINAL_TASKS; external;

