{ %pragma listlvl:2; }
{
 ******************************************************************************
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *                        MMM    MMM   XXX      XXX  DDDDDDDD                 *
 *                        MMMM  MMMM    XXX    XXX   DDDDDDDDDD               *
 *                        MM MMMM MM     XXX  XXX    DD      DDD              *
 *                        MM  MM  MM      XXXXXX     DD       DD              *
 *                        MM      MM       XXXX      DD       DD              *
 *          T  H  E       MM      MM       XXXX      DD       DD              *
 *                        MM      MM      XXXXXX     DD       DD              *
 *                        MM      MM     XXX  XXX    DD      DDD              *
 *                        MM      MM    XXX    XXX   DDDDDDDDDD               *
 *                       MMMM    MMMM  XXX      XXX  DDDDDDDD                 *
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *                 SSSSS Y     Y  SSSSS TTTTTTT EEEEEE M     M                *
 *                S       Y   Y  S         T    E      MM   MM                *
 *                S        Y Y   S         T    E      M M M M                *
 *                 SSSS     Y     SSSS     T    EEEEE  M  M  M                *
 *                     S    Y         S    T    E      M     M                *
 *                     S    Y         S    T    E      M     M  ..            *
 *                SSSSS     Y    SSSSS     T    EEEEEE M     M  ..            *
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *              ---  Version  3.999 000 alpha -- 31/10/2010 ---               *
 *                                                                            *
 *                by :                                                        *
 *                                                                            *
 *                     P. Wolfers                                             *
 *                         c.n.r.s.                                           *
 *                         Institut Neel (MCMF), Bat F,                       *
 *                         B.P.  166 X   38042  Grenoble Cedex                *
 *                                                FRANCE.                     *
 *                                                                            *
 *                                                                            *
 ******************************************************************************


///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                                                                           //
//                     Global Public Licence (GPL)                           //
//                                                                           //
//                                                                           //
//    This license described in this file overrides all other licenses       //
//    that might be specified in other files for this software.              //
//                                                                           //
//    This program is free software; you can redistribute it and/or          //
//    modify it under the terms of the GNU Lesser General Public             //
//    License as published by the Free Software Foundation; either           //
//    version 2.1 of the License, or (at your option) any later version.     //
//                                                                           //
//    This software is distributed in the hope that it will be useful,       //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      //
//    Library General Public License for more details.                       //
//                                                                           //
//    You should have received a copy of the GNU Lesser General Public       //
//    License along with this library (see COPYING.LIB); if not, write to    //
//    the Free Software Foundation :                                         //
//                         Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////



*******************************************************************************
*                                                                             *
*                                                                             *
*            MXD   Crystallographic  Object  Tree   Specific codes            *
*                                                                             *
*                                                                             *
*******************************************************************************


}


{****************     CPAS  version    *****************}
{
        *** Modification(s) from major version ***


                  ----

                 NOTHING

                  ----

}

{ Define all specific codes of MXD crystallographic tree builder pcdf input file }

type

  citm_codety = (
    { * Define all user item codes * }
    citm_unused,        citm_lsqblock,      citm_wavevect,      citm_npoladir,      citm_symtry,
    citm_no_05,         citm_no_06,         citm_no_07,         citm_no_08,         citm_no_09,
    citm_phase,         citm_atmgroup,      citm_no_12,         citm_no_13,         citm_no_14,
    citm_atom,          citm_catom,         citm_moment,        citm_mdsdsp,        citm_no_19,
    citm_constraint,
    citm_dathkl_xf2,    citm_dathkl_xsf,    citm_dathkl_xray,   citm_dathkl_xprf,
    citm_dathkl_nf2,    citm_dathkl_nsf,    citm_dathkl_nray,   citm_dathkl_nprf,
    citm_datcurve
  );

  cdir_codety = (       { * Define all directive codes * }
    cdir_unused,        cdir_center,        cdir_lattice,       cdir_space_group,   cdir_no_04,
    cdir_no_05,         cdir_no_06,         cdir_no_07,         cdir_no_08,         cdir_no_09,
    cdir_option,        cdir_fixed,         cdir_unfixed,       cdir_limits,        cdir_dsplpar
  );

  coef_codety = (       { * Define all internal coefficient codes * }
    coef_unused,   coef_h,        coef_k,        coef_l,        coef_rh,        {  00 .. 04 }
    coef_rk,       coef_rl,       coef_hh,       coef_kk,       coef_ll,        {  05 .. 09 }
    coef_sithsl,   coef_sh,       coef_sk,       coef_sl,       coef_selnb,     {  10 .. 14 }
    coef_rhbflg,   coef_no_16,    coef_no_17,    coef_no_18,    coef_no_19,     {  15 .. 19 }
    coef_no_20,    coef_qx,       coef_qy,       coef_qz,       coef_hx,        {  20 .. 24 }
    coef_hy,       coef_hz,       coef_no_27,    coef_no_28,    coef_no_29,     {  25 .. 29 }
    coef_no_30,    coef_fnr,      coef_fni,      coef_fmxr,     coef_fmyr,      {  30 .. 34 }
    coef_fmzr,     coef_fmxi,     coef_fmyi,     coef_fmzi,     coef_no_39,     {  35 .. 39 }
    coef_npola,    coef_no_46,    coef_no_47,    coef_no_48,    coef_no_49,     {  40 .. 44 }
    coef_no_50,    coef_obs,      coef_sig,      coef_weight,   coef_no_54,     {  45 .. 49 }
    coef_y_x,      coef_y_obs,    coef_y_sg,     coef_y_weight, coef_no_68,     {  50 .. 54 }
    coef_no_69,    coef_lchi2,    coef_cchi2,    coef_lmaxf,    coef_cmaxf      {  55 .. 59 }
  );

  virt_codety = (  virt_unused,     { * Define all virtual variable codes * }

    { Current Data dependant for User reference }
    virt_dat$calc, virt_dat$fn2,  virt_dat$fm2,  virt_dat$f2pola,

    { Current Phase Item related fields }
    virt_pha$scale,
    virt_pha$daa,  virt_pha$dbb,  virt_pha$dcc,
    virt_pha$dal,  virt_pha$dbe,  virt_pha$dga,  virt_pha$dvol,
    virt_pha$raa,  virt_pha$rbb,  virt_pha$rcc,
    virt_pha$ral,  virt_pha$rbe,  virt_pha$rga,  virt_pha$rvol,

    { * Current phase resulting LSQ_PARM * }

    { Direct and Reciprocal Metric tensors }
    virt_pha$dtaa, virt_pha$dtbb, virt_pha$dtcc, virt_pha$dtbc,  virt_pha$dtca,  virt_pha$dtab,
    virt_pha$rtaa, virt_pha$rtbb, virt_pha$rtcc, virt_pha$rtbc,  virt_pha$rtca,  virt_pha$rtab,

    { * Current AtmGroup related fields * }

    { Direct and Reciprocal transformation matrixs }
    virt_pha$dm11, virt_pha$dm12, virt_pha$dm13,
    virt_pha$dm21, virt_pha$dm22, virt_pha$dm23,
    virt_pha$dm31, virt_pha$dm32, virt_pha$dm33,
    virt_pha$rm11, virt_pha$rm12, virt_pha$rm13,
    virt_pha$rm21, virt_pha$rm22, virt_pha$rm23,
    virt_pha$rm31, virt_pha$rm32, virt_pha$rm33,

    { Rotation/Translation Matrix of the current AtmGroup }
    virt_grp$m11,  virt_grp$m12,  virt_grp$m13,  virt_grp$tx,
    virt_grp$m21,  virt_grp$m22,  virt_grp$m23,  virt_grp$ty,
    virt_grp$m31,  virt_grp$m32,  virt_grp$m33,  virt_grp$tz,

    { Effective Rotation/Translation Matrix of the current AtmGroup }
    virt_gre$m11,  virt_gre$m12,  virt_gre$m13,  virt_gre$tx,
    virt_gre$m21,  virt_gre$m22,  virt_gre$m23,  virt_gre$ty,
    virt_gre$m31,  virt_gre$m32,  virt_gre$m33,  virt_gre$tz
  );


  lsqopt_codes = (      { * Define all options codes * }
    opls_unused,    opls_shortlst,  opls_ncycle,    opls_listhkl,   opls_mxsithsl,  {  00 .. 04 }
    opls_misithsl,  opls_reject,    opls_mindiag,   opls_maxsing,   opls_maxcateg,  {  05 .. 09 }
    opls_acconv,    opls_reslist,   opls_parmlist,  opls_pstatres,  opls_cypstares, {  10 .. 14 }
    opls_fmagdisp,  opls_pfmagdisp, opls_symlist,   opls_cmatlist,  opls_mxcorrel,  {  15 .. 19 }
    opls_strend,    opls_strini,    opls_savcycle,  opls_atom_out,  opls_four_out,  {  20 .. 24 }
    opls_sigm_out                                                                   {  25  }
  );


